/*
 * This file is part of FGGL.
 *
 * FGGL is free software: you can redistribute it and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * FGGL is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along with FGGL.
 * If not, see <https://www.gnu.org/licenses/>.
 */

//
// Created by webpigeon on 24/07/22.
//

#ifndef FGGL_ENTITY_MODULE_HPP
#define FGGL_ENTITY_MODULE_HPP

#include "fggl/modules/module.hpp"
#include "fggl/assets/loader.hpp"

#include "fggl/entity/loader/loader.hpp"

namespace fggl::entity {

	struct ECS {
		constexpr static const char *name = "fggl::entity::ECS";
		constexpr static const std::array<modules::ModuleService, 1> provides = {
			EntityFactory::service
		};
		constexpr static const std::array<modules::ModuleService, 1> depends = {
			assets::Loader::service
		};
		static bool factory(modules::ModuleService name, modules::Services &serviceManager);
	};

	void install_component_factories(EntityFactory *factory);

} // namespace fggl::entity

#endif //FGGL_ENTITY_MODULE_HPP
